function [z_c zPI qbpp] = useQBPP(q,qbpp,p_c,param,p_ref,zPI)
% Implements the feedback linearizing controller for the choke pressure.


b0 = param.b0;
beta = param.beta;
A = param.A;
l = param.l;
k_c = param.k_c;
p0 = 10^5;

Z_c = [0 4 9 10 15 20 30 40 50 70]';
G_c = 1/700*[0 1 35 45 80 125 200 300 400 700]';
%g_c=@(z) interp1( Z_c, G_c, max(Z_c(1), min(z, Z_c(end))) );
g_cInv=@(g) interp1( G_c, Z_c, max(0, min(g, 1)) );

%%Using both qbpp and z_c:
%Set qbpp so that the nominal choke opening required is 50%
qbpp = k_c*0.5*sqrt(1400/1420)*sqrt((p_ref-p0)*10^-5)*0.001/60;%1000*0.001/60;
v = b0*(p_ref-p_c);

if p_c <= p0
    z_c = g_cInv(v);
else
    c = (1/(k_c*sqrt(1400/1420)*sqrt((p_c-p0)*10^-5)*0.001/60))*(qbpp+q-(A*l/beta)*v);
    if c < 0
        c = 0;
    elseif c > 1
        c = 1;
    end
%     if c == 0 || c == 1
%         qbpp = -q + k_c*c*sqrt(1400/1420)*sqrt((p_c-p0)*10^-5)*0.001/60 + (A*l/beta)*v;
%     end
    z_c = g_cInv(c);
end




end