function [z_c p_hat qerr] = useQBPP(q_c,qbpp,p_c,param,p_ref,p_hat,qerr)
% Implements the feedback linearizing controller for the choke pressure.


b0 = param.b0;
beta = param.beta;
A = param.A;
l = param.l;
k_c = param.k_c;
p0 = 1.0131*10^5;
Lp =param.Lp;
Li= param.Li;


Z_c = (1/100)*[0 4 9 10 15 20 30 40 50 70]';
G_c = 1/700*[0 1 35 45 80 125 200 300 400 700]';
%g_c=@(z) interp1( Z_c, G_c, max(Z_c(1), min(z, Z_c(end))) );
g_cInv=@(g) interp1( G_c, Z_c, max(0, min(g, 1)) );

    function yDot = obs(t,y)
        p_hat = y(1);
        qerr = y(2);
        p_hatDot = beta/(A*l)*(qbpp - q_c + qerr - Lp*(A*l/beta)*(p_hat-p_c));
        qerrDot = -Li*(A*l/beta)*(p_hat-p_c);
        yDot = [p_hatDot qerrDot]';     
    end

y0 = [p_hat qerr]';

y = ode4(@obs,[0:0.01:0.05], y0);
y = y';
y = y(:,end);
p_hat = y(1);
qerr = y(2);

%%Using both qbpp and z_c:
%Set qbpp so that the nominal choke opening required is 50%
v = b0*(p_ref-p_c);

if p_c <= p0
    z_c = g_cInv(v);
else
    c = (1/(k_c*sqrt(1400/1475)*sqrt((p_c-p0)*10^-5)*0.001/60))*(qbpp+q_c-(A*l/beta)*v);
    if c < 0
        c = 0;
    elseif c > 1
        c = 1;
    end
%     if c == 0 || c == 1
%         qbpp = -q + k_c*c*sqrt(1400/1420)*sqrt((p_c-p0)*10^-5)*0.001/60 + (A*l/beta)*v;
%     end
    z_c = g_cInv(c);
end




end