function [z_c,x01,q_bpp] = IMC(p_c,p_b,param,x01)
% Implements the internal model controller with or without feedback
% linearization

cSys = param.cSys;
k_c = param.k_c;

p0 = 10^5;

p_cRef = 240*10^5-1420*9.81*1540-5.0909e+04;
%Error in bottom hole pressure
e = 240*10^5 - p_b;

% Set the bpp flow 
q_bpp = k_c*0.4*sqrt(1400/1420)*sqrt((p_cRef-p0)*10^-5)*0.001/60;

t = [0 0.05];
%Run controllers
[Y,t,X] = lsim(ss(cSys),e*ones(size(t)),t,x01);
x01 = X(end,:);


r = Y(end);


Z_c = [0 4 9 10 15 20 30 40 50 70]';
G_c = 1/700*[0 1 35 45 80 125 200 300 400 700]';
%g_c=@(z) interp1( Z_c, G_c, max(Z_c(1), min(z, Z_c(end))) );
g_cInv=@(g) interp1( G_c, Z_c, max(0, min(g, 1)) );

if p_c <= p0
    u = 0;
else
    % feedback linearization
%     u = (q_bpp - r)/(k_c*sqrt(1400/1420)*sqrt((p_c-p0)*10^-5)*0.001/60);
    % no linearization
    u = -r;
end

z_c = g_cInv(u);


end