function [z_c,x01,q_bpp] = IMCObserver(y,p_c,param,x01)
% Implements the internal model controller with an additional state
% feedback for loop shaping.

beta = param.beta;
rho = param.rho;
A = param.A;
l = param.l;
dh = 1540/5;
g = 9.81;
k_c = param.k_c;
p2a = 5.0909e+04;
k1 = (1/5-0.5)*p2a;

p0 = 10^5;

% p_cRef = 225*10^5-1420*9.81*1540-5.0909e+04;
% e = 225*10^5 - p_b;

p_ref1 = 240*10^5;
p_ref2 = p_ref1 - k1 - rho*g*dh;
p_ref3 = p_ref2 - k1 - rho*g*dh;
p_ref4 = p_ref3 - k1 - rho*g*dh;
p_ref5 = p_ref4 - k1 - rho*g*dh;
p_cRef = p_ref5 - k1/2 - rho*g*dh/2;

y_err = [p_ref1-y(1),-y(6),p_ref2-y(2),-y(7),p_ref3-y(3),-y(8),p_ref4-y(4),-y(9),p_ref5-y(5)]';
e = y_err(1);

q_bpp = k_c*0.5*sqrt(1400/1420)*sqrt((p_cRef-p0)*10^-5)*0.001/60;

sys = ss(tf([1 2 (2*pi/12)^2],[1 0 (2*pi/12)^2]));
t = [0 0.05];
[Y,t,X] = lsim(sys,e*ones(size(t)),t,x01);
x01 = X(end,:);


beta1 = beta/(A*l);

K = [6 -2.5*10^8 6 -2.5*10^8 6 -2.5*10^8 6 -2.5*10^8 6];
r = K*y_err + Y(end);

%r = k1*(p_cRef-p_c) - k2*q + k3*(225*10^5-p_b) + Y(end);

Z_c = [0 4 9 10 15 20 30 40 50 70]';
G_c = 1/700*[0 1 35 45 80 125 200 300 400 700]';
%g_c=@(z) interp1( Z_c, G_c, max(Z_c(1), min(z, Z_c(end))) );
g_cInv=@(g) interp1( G_c, Z_c, max(0, min(g, 1)) );

if p_c <= p0
    u = 0;
else
    u = (q_bpp - r/beta1)/(k_c*sqrt(1400/1420)*sqrt((p_c-p0)*10^-5)*0.001/60);
end

z_c = g_cInv(u);


end