function [RealOpening v_old I xss] = getRealChokeOpening(z_c,z_cLast,v_old,I, xss, ROL)
%Implements the friction in the choke
%See flow chart in project report

dT = 0.05;
S = 5;
J = 2;
if z_c < 0
    RealOpening = 0;
elseif z_c > 100
    RealOpening = 100;
else
    v_new = (z_c-z_cLast)/dT;
    if sign(v_new) == sign(v_old)
        if I == true
            if abs(z_c-xss)>J
                I = 0;
                RealOpening = z_c - sign(v_new)*(S-J)/2;
            else
                RealOpening = ROL;
            end
        else
            if abs(z_c-xss)>S
                RealOpening = z_c - sign(v_new)*(S-J)/2;
            else
                RealOpening = ROL;
            end
        end
    else
        if sign(v_new) == 0;
            I = 1;
            xss = z_cLast;
            RealOpening = ROL;
        else
            xss = z_cLast;
            RealOpening = ROL;
        end
    end
    v_old = v_new;
end




end